<?php
/**
 * Created by PhpStorm.
 * User: FrédéricGuichard
 * Date: 05/05/2017
 * Time: 11:36
 */

namespace Feedbii\DataCollector;


/**
 * Class AbstractDataCollector
 * @package Feedbii\DataCollector
 */
abstract class AbstractDataCollector
{
    /**
     * @var
     */
    protected $db;

    /**
     * @var \DateTime
     */
    private $dateFrom;

    /**
     * @var \DateTime
     */
    private $dateTo;


    public function __construct($db)
    {
        $this->db = $db;
        $this->dateFrom = (new \DateTime())->sub(new \DateInterval('P1D'));
        $this->dateTo = new \DateTime();
    }

    /**
     * @return \DateTime
     */
    public function getDateFrom()
    {
        return $this->dateFrom;
    }

    /**
     * @param mixed $dateFrom
     * @return $this
     */
    public function setDateFrom($dateFrom)
    {
        if (!$dateFrom instanceof \DateTime){
            $dateFrom = new \DateTime($dateFrom);
        }
        $this->dateFrom = $dateFrom;
        return $this;
    }

    /**
     * @return \DateTime
     */
    public function getDateTo()
    {
        return $this->dateTo;
    }

    /**
     * @param mixed $dateTo
     * @return $this
     */
    public function setDateTo($dateTo)
    {
        if (!$dateTo instanceof \DateTime){
            $dateTo = new \DateTime($dateTo);
        }
        $this->dateTo = $dateTo;
        return $this;
    }
}